/*
 * Copyright (c) W. Lenerz 2023.
 * This code is subject to the GPL, version 3 or later.
 */
package drivers.ser;

/**
 *
 * @author wolf
 */
public class PortnameShortener
{
    /**
     * Make a name for a serial port that the OS will recognize, from the long name returned by the driver for display purposes.
     * 
     * @param longName the long name dame by the driers: "x: OSNAME ( -> long name)"
     * @return 
     */
    public static final String makeOSName (final String longName)
    {
        int place = longName.indexOf(";");
        if (place==-1 || place>=longName.length()-1)
            return "";
        String result = longName.substring(place+1).trim();
        place = result.indexOf("t");
   //     if (place==-1 || place>=result.length()-Driver.SER_SEP.length()-1)
        if (place==-1 || place>=result.length()-1)
            return "";
        return result.substring(+5);
    }
}
