package smsqmulator;

/**
 * The independent thread that actually handles the emulation on a "g","gb" or "x" command.
 * 
 * @author and copyright (c) Wolfgang Lenerz 2012-2023.
 */

public interface EmulationThread //extends Thread //javax.swing.SwingWorker <Void,Void>
{
    public void endEmulation();
    public void switchLogging (boolean logInstructions);
    public void setckmem (boolean checkmem);
    public void setmemWatched (int address);
    public void setUpperLimit (int address);
    public void setCondition (int dataReg,int addrReg,int condValue,boolean isContent,int address);
    public void resume();
    public void suspend();
    public void stop();
    public void start();
    /**
     * Sets the interval between screen updates.
     * 
     * @param tim the interval between screen updates in milliseconds.
     */
    public void setScreenUpdateInterval(int tim);
}
