package ui;

/**
 * This handles resetting from within S%MSQE.
 * Basically, a "RESET" command from within SMSQE goes to the TrapDispatcher which in turn would call Monitor.reset() which kills the EmulationThread.
 * As we're within SMSQE, i.e. within the emulation thread, that thread would just kill itself - so the program would just hang.
 * Hence this little independent thread, wich calls Monitor.reset();
 * @author and copyright (c) Wolfgang Lenerz 2019
 * @version
 * 1.00 initial version.
 */
public class ResetThread extends Thread
{
    private final smsqmulator.Monitor mon;
    
    public ResetThread(smsqmulator.Monitor mon)
    {
        this.mon=mon;
    }
    
    @Override
    public void run()
    {
        this.mon.reset();
    }
}
